<?php
/**
 * Fiona Theme Customizer.
 *
 * @package Fiona
 */

 if ( ! class_exists( 'News25_Customizer' ) ) {

	/**
	 * Customizer Loader
	 *
	 * @since 1.0.0
	 */
	class News25_Customizer {

		/**
		 * Instance
		 *
		 * @access private
		 * @var object
		 */
		private static $instance;

		/**
		 * Initiator
		 */
		public static function get_instance() {
			if ( ! isset( self::$instance ) ) {
				self::$instance = new self;
			}
			return self::$instance;
		}

		/**
		 * Constructor
		 */
		public function __construct() {
			/**
			 * Customizer
			 */
			add_action( 'customize_preview_init',array( $this, 'news25_customize_preview_js' ) );
			add_action( 'customize_register',array( $this, 'news25_customizer_register' ) );
			add_action( 'after_setup_theme',array( $this, 'news25_customizer_settings' ) );
		}
		
		/**
		 * Add postMessage support for site title and description for the Theme Customizer.
		 *
		 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
		 */
		function news25_customizer_register( $wp_customize ) {
			
			$wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
			$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
			$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
			$wp_customize->get_setting( 'background_color' )->transport = 'postMessage';
			$wp_customize->get_setting('custom_logo')->transport = 'refresh';
			
			/**
			 * Helper files
			 */
			require NEWS25_PARENT_INC_DIR . '/custom-controls/font-control.php';
			require NEWS25_PARENT_INC_DIR . '/custom-controls/news25-category-dropdown-control.php';
			require NEWS25_PARENT_INC_DIR . '/custom-controls/editor/class/class-news25-page-editor.php';
			require NEWS25_PARENT_INC_DIR . '/sanitization.php';
		}

		/**
		 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
		 */
		function news25_customize_preview_js() {
			wp_enqueue_script( 'news25-customizer', NEWS25_PARENT_URI . '/assets/js/customizer-preview.js', array( 'customize-preview' ), '20151215', true );
		}
		
		// Include customizer customizer settings.
			
		function news25_customizer_settings() {
			require NEWS25_PARENT_INC_DIR . '/customize/news25-header.php';
			require NEWS25_PARENT_INC_DIR . '/customize/news25-breakingnews.php';
			require NEWS25_PARENT_INC_DIR . '/customize/news25-footer.php';
			require NEWS25_PARENT_INC_DIR . '/customize/news25-blog.php';
			require NEWS25_PARENT_INC_DIR . '/customize/news25-general.php';
			require NEWS25_PARENT_INC_DIR . '/customize/customizer_recommended_plugin.php';
			require NEWS25_PARENT_INC_DIR . '/customize/customizer_import_data.php';
			require NEWS25_PARENT_INC_DIR . '/customize/news25-premium.php';
		}

	}
}// End if().

/**
 *  Kicking this off by calling 'get_instance()' method
 */
News25_Customizer::get_instance();